<?php
/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 */
class m120327_135311_rights_data extends CDbMigration
{
    public function up()
    {
        $this->execute("INSERT INTO `AuthItem` (`name`, `type`, `description`, `bizrule`, `data`) VALUES
        ('Authenticated', 1, 'Authenticated', NULL, 'N;'),
        ('commenting', 1, 'Commenting something', NULL, 'N;'),
        ('writeComment', 0, 'Write Comment', NULL, 'N;'),
        ('readComment', 0, 'Read Comment', NULL, 'N;'),
        ('deleteComment', 0, 'Delete Comment', NULL, 'N;'),
        ('manageComments', 1, 'Manage Comments', NULL, 'N;');");

        $this->execute("INSERT INTO `AuthItemChild` (`parent`, `child`) VALUES
        ('Authenticated', 'commenting'),
        ('commenting', 'readComment'),
        ('commenting', 'writeComment'),
        ('manageComments', 'commenting'),
        ('manageComments', 'deleteComment')
        ");
    }

    public function down()
    {
        $this->delete('AuthItem', "name in ('commenting', 'writeComment', 'readComment', 'deleteComment', 'manageComments')");
        $this->delete('AuthItemChild', "child in ('commenting', 'writeComment', 'readComment', 'deleteComment', 'manageComments')");
        return true;
    }

    /*
     // Use safeUp/safeDown to do migration with transaction
     public function safeUp()
     {
     }

     public function safeDown()
     {
     }
     */
}