<?php
$this->pageTitle = 'Reports';
Yii::app()->getClientScript()->registerCssFile($this->module->assetsPath.'/admin/css/reports.css');

$formsDataProvider = $forms->search();
$formsDataProvider->Pagination = false;

if($currentForm && $currentForm->formdata) {
	$displayData = array();
	$displayColumns = array('created_at:raw:');
	foreach(array_keys($currentForm->formdata[0]->getDisplayData()) as $name) {
		$displayColumns[$name] = array(
			'name'=>$name,
			'header'=>$currentForm->getElementLabel($name),
			'type'=>'html'
		);
	}
	foreach($currentForm->formdata as $fd) {
		$displayData[] = array_merge(
			array('created_at'=>$fd->created_at),
			$fd->getDisplayData()
		);
	}
	$displayDataProvider = new CArrayDataProvider($displayData, array(
		'keyField'=>false
	));
}
?>
<div class="fg-reports-list">
	<div class="list-box forms-list">
		<div class="list-title">Reports</div>
		<div class="list-box-content">
			<ul>
			<?php foreach($formsDataProvider->getData() as $data): ?>
				<li<?php if($currentForm && $currentForm->id == $data->id) echo ' class="active"' ?>>
					<?php echo CHtml::link($data->name, array('reports', 'form_id'=>$data->id)); ?>
				</li>
			<?php endforeach; ?>
			</ul>
		</div>
	</div>
	<?php if($currentForm): ?>
	<div class="list-box reports">
		<div class="list-title"><?php echo CHtml::encode($currentForm->name); ?> (<?php echo count($currentForm->formdata); ?>)</div>
		<?php if($currentForm->formdata): ?>
		<?php echo CHtml::link('Download', array('reports', 'form_id'=>$currentForm->id, 'csv'=>1)); ?>
		<?php endif; ?>
		<div class="list-box-content">
			<?php if($currentForm->formdata): ?>
			<?php
			$this->widget('zii.widgets.grid.CGridView', array(
				//'id'=>'formdata-grid',
				'dataProvider'=>$displayDataProvider,
				//'filter'=>$model,
				'htmlOptions'=>array('style'=>'width:740px'),
				'pager'=>array(
					'header'=>'',
					'firstPageLabel'=>'&lt;&lt;',
					'prevPageLabel'=>'&lt;',
					'nextPageLabel'=>'&gt;',
					'lastPageLabel'=>'&gt;&gt;',
				),
				'columns'=>$displayColumns
			));
			?>
			<?php else: ?>
			<div class="empty">No reports</div>
			<?php endif; ?>
		</div>
	</div>
	<?php endif; ?>
</div>