<?php
/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 *
 * Widget for viewing navigation tree
 */

class GooglesitemapsWidget extends BaseJuiWidget
{
     /**
     * @var string $rootfolderId contains the ID of the rootfolder.
    */
    public $rootfolderId;

    /**
     * @var string $hostParam can be set to build absolute Urls (eg 'http://www.gentics.com')
     */
    public $hostParam;

    /**
     * @var array $contentTypes contains the Type Id's which content to show (10007,10008,ect)
    */
    public $contentTypes;

    /**
     * @var string $hideParam contains the Name of the object Parameter which is can be set to not show content
    */
    public $hideParam;

    /**
     * @var string $containerParam contains the Name of the object Parameter which will be checked against the value to show the content
    */
    public $containerParam;

        /**
     * @var string $containerParamValue contains the value the object Parameter need to have to show the content
    */
    public $containerParamValue;

    /**
     * @var string $outputFormatValue sets the choosen Output Format in the View
    */
    public $outputFormatValue;

    /**
     * @var int the number of seconds in which the cached value will expire. 0 means never expire.
     */
    public $cacheTime;

    /**
     * language
     * @var lang
     */
    public $lang = '';

    /**
     * Base href for current page
     * @var int
     */
    public $baseHref = '';

    /**
     * @var string GCC request params. Comma separated.
     */
    public $gccRequestParams;

    /**
     * @var string $sorting contains sorting expression
     */
    public $sorting;
    /**
     * Initializes the widget.
     *
     * @return void
     */
    public function init()
    {
        //die('this is init');
    }

    /**
     * renders view
     *
     * @throws Exception
     * @return void
     */
    public function run()
    {

        /*
         * Get values from widget option for Googlesitemaps
         * if it is set otherwise it will be taken from module
         */
        $rootfolderId = "";
        if(isset($this->rootfolderId)){
            $rootfolderId = $this->rootfolderId;
        }
        $hostParam = null;
        if(isset($this->hostParam)){
            $hostParam = $this->hostParam;
        }
        $contentTypes = null;
        if(isset($this->contentTypes)){
            $contentTypes = $this->contentTypes;
        }
        $hideParam = null;
        if(isset($this->hideParam)){
            $hideParam = $this->hideParam;
        }
        $containerParam = null;
        if(isset($this->containerParam)){
            $containerParam = $this->containerParam;
        }
        $containerParamValue = null;
        if(isset($this->containerParamValue)){
            $containerParamValue = $this->containerParamValue;
        }
        $outputFormatValue = "";
        if(isset($this->outputFormatValue)){
            $outputFormatValue = $this->outputFormatValue;
        }
        $cacheTime = null;
        if(isset($this->cacheTime)){
            $cacheTime = $this->cacheTime;
        }
        $gccRequestParams = null;
        if(isset($this->gccRequestParams)){
            $gccRequestParams = $this->gccRequestParams;
        }
        $sorting = null;
        if(isset($this->sorting)){
            $sorting = $this->sorting;
        }

        if ($rootfolderId != "") {
            $content = new Googlesitemaps($rootfolderId, $hostParam, $contentTypes, $hideParam, $containerParam , $containerParamValue, $outputFormatValue, $cacheTime, $gccRequestParams , $sorting);
        } else {
            throw new Exception('GooglesitemapsWidget error: rootfoldweId is a required parameter and can`t be blank ');
        }

        if (!empty($content->data)) {
            $this->lang = substr(Yii::app()->language, 0, 2);
            $this->render('GooglesitemapsWidget', array('contentList'=>$content->data,'lvl' => 1,'hostParam'=>$content->hostParam,'outputFormat'=>$content->outputFormatValue));
        }
    }
}