/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 *
 */

(function ($) {

    $.fn.dhtmlTreeUserAssignment = function (options) {
        var defaults = {
            userId:null,
            updateUrl:null,
            treeData:null,
            treeClass:'dhtmlTree',
            imagePath:null,
            enableEditing:true,
            t:{},
            hiddenFields:{}
        };
        var t = function (msg) {
            if (options.t[msg]) {
                return options.t[msg];
            } else {
                return msg;
            }
        };
        options = $.extend(defaults, options);
        this.each(function () {
            var $this = $(this);

            $this.append("<div class='" + options.treeClass + "'></div>");
            var tree = new dhtmlXTreeObject({
                parent:$this.find('.' + options.treeClass)[0],
                skin:'dhx_skyblue',
                image_path:options.imagePath,
                checkbox:true
            });
            tree.loadJSONObject({
                    id:0,
                    item:[
                        {
                            id:'root',
                            text:t('Personalisation attributes tree'),
                            item:options.treeData
                        }
                    ]}
            );
            tree.openAllItems(0);
            tree.disableCheckbox('root', true);
            if (!options.enableEditing) {
                var allIds = tree.getAllSubItems(0).split(',');
                for (var id in allIds) {
                    console.log(allIds[id]);
                    tree.disableCheckbox(allIds[id], true);
                }
            }
            tree.attachEvent("onCheck", function (id, state) {
                $.post(options.updateUrl, $.extend({}, {id:id, state:state, user_id:options.userId}, options.hiddenFields), {

                });
            });
        });
    };

}(jQuery))
;