<?php


/**
 * 
 **/
class ChartWidget extends BaseWidget
{
    /**
     * Maximum chart width
     *
     * @public int
     **/
    public $width = 200;
    
    /**
     * Chart title
     *
     * @public string
     **/
    public $title;

    /**
     * Format array('title' => 'Population', 'value' => '299.2')
     *
     * @public string
     **/
    public $rows = array();

    /**
     * Units of measurment
     *
     * @public string
     **/
    public $units;

    public function run()
    {
        $maxValue = ~PHP_INT_MAX;
        foreach($this->rows as $row)
        {
            $maxValue = max($maxValue, $row['value']);
        }
        foreach($this->rows as &$row)
        {
            $row['width'] = $maxValue == 0 ? 0 : (($this->width / $maxValue) * $row['value']);
        }
        $this->render('ChartWidget');
    }

}
