<?php
/**
 * Gentics Portal.Node PHP
 * Author & Copyright (c) by Gentics Software GmbH
 * sales@gentics.com
 * http://www.gentics.com
 * Licenses can be found in the LICENSE.txt file in the root-folder of this installation
 * You must not use this software without a valid license agreement.
 *
 * Controller for functional testing
 * Display each widget on separate page
 */


class WidgetsTestsController extends BaseController
{
    /*
     * Simulate content source behaviour
     */
    public function getCss($file, $timestamp = null, $combine = true, $media = '')
    {
        Yii::app()->clientScript->registerCssFile($file, $media, $timestamp, $combine, true, true);
    }
    public function getJs($file, $timestamp = null, $combine = true)
    {
        Yii::app()->clientScript->registerScriptFile($file, CClientScript::POS_HEAD,
                array(), $timestamp, $combine, true, true);
    }

    /**
     * Display UserLoginWidget widget
     *
     * @return void
     */
    public function actionUserLogin()
    {
        $this->render('userLogin');
    }

    /**
     * Display UserLogoutWidget
     *
     * @return void
     */
    public function actionUserLogout()
    {
        $this->render('userLogout');
    }

    /**
     * Display UserLogoutWidget
     *
     * @return void
     */
    public function actionUserRegistration()
    {
        $this->render('userRegistration');
    }

    /**
     * Display UserRecoveryWidget
     *
     * @return void
     */
    public function actionUserRecovery()
    {
        $this->render('userRecovery');
    }

    /**
     * Display UserProfileWidget
     *
     * @return void
     */
    public function actionUserProfile()
    {
        $this->render('userProfile');
    }

    /**
     * Display UserProfileEditWidget
     *
     * @return void
     */
    public function actionUserProfileEdit()
    {
        $this->render('userProfileEdit');
    }

    /**
     * Display UserStatusWidget
     *
     * @return void
     */
    public function actionUserStatus()
    {
        $this->render('userStatus');
    }

    public function actionUserPasswordChange()
    {
        $this->render('userPasswordChange');
    }

    /**
     * Display CommentsWidget
     *
     * @return void
     */
    public function actionCommentsComments()
    {
        $this->render('commentsComments');
    }

    public function actionCommentsAmount()
    {
        $this->render('commentsAmount');
    }

    /**
     * Display LikeWidget
     *
     * @return void
     */
    public function actionLikeLike()
    {
        $this->render('likeLike');
    }

    /**
     * Display LanguageWidget
     *
     * @return void
     */
    public function actionLanguageLanguage()
    {
        $this->render('languageLanguage');
    }

    public function actionPersonalisationManage()
    {
        $this->render('personalisationManage');
    }

    public function actionPersonalisationAssign()
    {
        $this->render('personalisationAssign');
    }

    public function actionSimpleSearch()
    {
        $this->render('simpleSearch');
    }

    public function actionAdvancedSearch()
    {
        $this->render('advancedSearch');
    }

    public function actionSearchResult()
    {
        $this->render('searchResult');
    }

    public function actionFriendsSearch()
    {
        $this->render('friendsSearch');
    }

    public function actionFriendsSearchResult()
    {
        $this->render('friendsSearchResult');
    }

    public function actionFriendsList()
    {
        $this->render('friendsList');
    }

    public function actionRecoveryChangePassword()
    {
        $this->render('recoveryChangePassword');
    }

    public function actionPersonalizedContent()
    {
        $this->render('personalizedContent');
    }

    public function actionShoppingCart()
    {
        $this->render('shoppingcart');
    }
    public function actionShoppingCartCart()
    {
        $this->render('shoppingcartCart');
    }
}
